#! ./sizzle -s
!#
;; benchmark/tailrecurse.scm
;;
;; This file tests Sizzle's tail recursion properties.
;;
;; Copyright (C) 2000 Martin Grabmueller <mgrabmue@cs.tu-berlin.de>
;;
;; This is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;; 
;; This software is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;; 
;; You should have received a copy of the GNU General Public License
;; along with this package; see the file COPYING.  If not, write to
;; the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;; Boston, MA 02111-1307, USA.  
;;

;(set! gc-message #t)

;; The following procedures call each other tail recursively.
(define (g n)
  (f n))
(define (f n)
;  (if (zero? (modulo n 100000))
;      (begin (display n) (newline)))
  (if (< n 1000000)
      (g (+ n 1))))

(f 0)
(display "gc-stats: ") (display (gc-stats)) (newline)
