#! /bin/sh
exec ../src/sizzle -qs $0 $*
!#
;; test/signal.scm -- tests for signal handling
;;
;; Copyright (C) 2000 Martin Grabmueller <mgrabmue@cs.tu-berlin.de>
;;
;; This is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.
;; 
;; This software is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;; 
;; You should have received a copy of the GNU General Public License
;; along with this package; see the file COPYING.  If not, write to
;; the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;; Boston, MA 02111-1307, USA.  

;; Load the test framework.

(load "test-suite.scm")

(use-modules (core posix))

(begin-section "signal")
(define signum #f)
(signal 15 (lambda (sig) (set! signum sig)))
(signal 2 (lambda (sig) (set! signum sig)))
(kill (getpid) 15)
(pass-if signum 15 =)
(kill (getpid) 2)
(pass-if signum 2 =)

(test-summary)
